/* The game logic (no view code or direct user interaction)
The game is a simple word game which is based on Mastermind
*/

#pragma once
#include <string>

//make syntax Unreal-friendly
using FString = std::string;
using int32 = int;

// all values initialized to 0
struct FBullCowCount
{
	int32 Bulls = 0;
	int32 Cows = 0;
};


enum class EGuessStatus {
	Invalid_status,
	Okay,
	Not_Isogram,
	Word_length,
	Not_lowercase
};

class FBullCowGame{
public:
	FBullCowGame(); //Instantiate a new game
	void ResetGame(); 
	void SetHiddenWord();

	
	int32 GetHiddenWordLength()const;
	FString GetHiddenWord()const;
	int32 GetEasiestDiffficulty()const;
	int32 GetHardestDiffficulty()const;
	int32 GetMaxTries()const;
	int32 GetCurrentTry()const;

	bool IsGameWon()const;
	EGuessStatus ValidateAnswer(FString)const;
	// counts bulls and cows and increases try number, assuming valid guess
	FBullCowCount SubmitValidGuess(FString);
	

private:
	//Look above at constructor
	int32 MyCurrentTries;
	FString MyHiddenWord;
	int32 EasiestDifficulty;
	int32 HardestDifficulty;
	bool bIsGameWon;
	
	bool IsIsogram(FString) const;
	bool IsLowercase(FString) const;
};

